<?php

namespace STM\Competition;

use STM\Competition\CompetitionType;
use STM\Competition\CompetitionStatus;
use STM\StmFactory;
use STM\User\UserGroup;

/**
 * Test class for CompetitionSelection.
 * Generated by PHPUnit on 2012-02-06 at 18:51:59.
 * @group competition
 */
class CompetitionSelectionTest extends \PHPUnit_Framework_TestCase {

    /** @var CompetitionSelection */
    protected $object;

    protected function setUp() {
        $this->object = new CompetitionSelection();
    }

    public function testSet_competition_type() {
        $this->assert_set_method('setCompetitionType', null, CompetitionType::PLAYOFF, 'id_competition_type');
    }

    public function testSet_team() {
        $teams = StmFactory::find()->Team->findAll();
        if ($teams) {
            $this->object->setTeam(array_shift($teams));
            $this->assertTrue(is_int(strpos($this->object->getSelectQuery()->__toString(), 'id_team =')));
        }
    }

    public function testSet_competition_manager() {
        $users = StmFactory::find()->User->findByUserGroup(UserGroup::COMPETITION_MANAGER);
        if ($users) {
            $this->object->setCompetitionManager(array_shift($users));
            $this->assertTrue(is_int(strpos($this->object->getSelectQuery()->__toString(), 'id_user =')));
        }
    }

    public function testSet_category() {
        $categories = StmFactory::find()->CompetitionCategory->findAll();
        if ($categories) {
            $this->object->setCategory(array_shift($categories));
            $this->assertTrue(is_int(strpos($this->object->getSelectQuery()->__toString(), "id_category = '")));
        }
    }

    public function testSet_competition_statuses() {
        $this->object->setCompetitionStatuses(array(CompetitionStatus::VISIBLE));
        $this->assertTrue(is_int(strpos($this->object->getSelectQuery()->__toString(), 'WHERE (id_status IN')));
    }
    
    public function testSet_limit() {
        $this->object->setLimit(false);
        $this->assertFalse(strpos($this->object->getSelectQuery()->__toString(), 'LIMIT'));
    }

    public function testgetSelectQuery() {
        parent::assertInstanceOf('\STM\DB\SQL\SelectQuery', $this->object->getSelectQuery());
    }

    private function assert_set_method($set_method, $bad_value, $valid_value, $sql_name) {
        $this->object->$set_method($bad_value);
        $this->assertFalse(strpos($this->object->getSelectQuery()->__toString(), $sql_name . ' ='));        
        $this->object->$set_method($valid_value);
        $this->assertTrue(is_int(strpos($this->object->getSelectQuery()->__toString(), $sql_name . ' =')));
    }
            
}

?>
